Subject: bug#31943: Some Maven bugs

From: Julien Lepiller <[email-masked]>
Date: Sat, 23 Jun 2018 12:20:33 +0200

Le Sat, 23 Jun 2018 00:39:35 +0200,
Björn Höfling <[email-masked]> a écrit :

> Maven is now part of Guix, yeah! I gave it a try and found some bugs
> which I post collectively here. I don't know yet where exactly they
> come from and if they are trivial or not to fix. So if you think they
> should better go each into a separate bug report, please separate
> them.
> 
> For reference, I'm on Ubuntu with:
> 
> $> guix pull --list-generations | tail --lines=6  
> guile: warning: failed to install locale
> warning: failed to install locale: Invalid argument
> 
> Generation 2    Jun 22 2018 21:53:40    (current)
>   guix 18ab54d
>     repository URL: https://git.savannah.gnu.org/git/guix.git
>     commit: 18ab54d4a2aaf932b14e69c30650c1d2c4db33c7
> 
> 
> 1) The following propagated inputs are used from bash scripts
> and are missing: which, coreutils
> 
> 2) There is something wrong with the version output:

Fixed with 7504f3c3d3a2fbd0f901757a9bd3175e424c11ca and
e27c43d94e23daf6b114b03688a51c924890a286 :)

> [...]
> 
> 3) The -version part is already handled by Java code. So I tried to
> debug Maven remotely from Eclipse, but it failed with a message saying
> that debug symbols were missing. I want to verify this again, but
> could this be a problem of the ant-build-system removing debug
> symbols?

I think our ant-build-system doesn't add debugging symbols to our java
packages. That's where it should be fixed (if we want to fix it?)

> 
> 4) I cannot use icedteaX (x \in {1,2}) (i.e. X=2 means JDK 1.7) with
> Maven. Is this a bug or a fact?
> 

This is because some of the dependencies cannot be built without java8.
I think there is an option in ant to build with a new jdk but stay
compatible with older jdks. Our ant-build-system should probably use
that.

> [...]
> 
> 5) Maven complains about the logger output:
> 
> Is this comment related to the WARNING? Will it go away with
> maven-slf4j-provider?

Exactly.

> 
> 
> 6) Maven does not compile Java 1.8 code.
> 

Ok, this is unexpected, and that's what I'll be working on next.

> 
> 
> 7) I have some trouble executing the tests. This is indeterministic
> (!), sometimes is is successful, sometimes I get an error:
> 

Weird too.

> 
> 
> 8) BTW maven is NOT creating a reproducible output. That's important
> if you want to use it to as a build tool for Guix:
> 

I think this is expected. I've seen a bug report about that, but can't
find it anymore. We could reuse the repack-jar phase from the
ant-build-system though.

> Björn

Thank you for your reports!